/* Utils.c generated by valac 0.56.17, the Vala compiler
 * generated from Utils.vala, do not modify */

/*-
 * Copyright (c) 2017-2018 Artem Anufrij <artem.anufrij@live.de>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Artem Anufrij <artem.anufrij@live.de>
 */

#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <granite.h>
#include <gtk/gtk.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

VALA_EXTERN gchar* play_my_music_utils_get_formated_duration (guint64 duration);
VALA_EXTERN gboolean play_my_music_utils_is_audio_file (const gchar* mime_type);
VALA_EXTERN void play_my_music_utils_delete_uri_recursive (const gchar* uri);
VALA_EXTERN gchar* play_my_music_utils_markdown_format (const gchar* input);
VALA_EXTERN void play_my_music_utils_set_custom_css_style (GdkScreen* screen);

gchar*
play_my_music_utils_get_formated_duration (guint64 duration)
{
	guint seconds = 0U;
	guint hours = 0U;
	guint minutes = 0U;
	gchar* _tmp1_;
	gchar* result;
	seconds = (guint) (duration / 1000000000);
	if (seconds < ((guint) 3600)) {
		guint minutes = 0U;
		gchar* _tmp0_;
		minutes = seconds / 60;
		seconds -= minutes * 60;
		_tmp0_ = g_strdup_printf ("%u:%02u", minutes, seconds);
		result = _tmp0_;
		return result;
	}
	hours = seconds / 3600;
	seconds -= hours * 3600;
	minutes = seconds / 60;
	seconds -= minutes * 60;
	_tmp1_ = g_strdup_printf ("%u:%02u:%02u", hours, minutes, seconds);
	result = _tmp1_;
	return result;
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

gboolean
play_my_music_utils_is_audio_file (const gchar* mime_type)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean result;
	g_return_val_if_fail (mime_type != NULL, FALSE);
	if (g_str_has_prefix (mime_type, "audio/")) {
		_tmp1_ = !string_contains (mime_type, "x-mpegurl");
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		_tmp0_ = !string_contains (mime_type, "x-scpls");
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}

void
play_my_music_utils_delete_uri_recursive (const gchar* uri)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (uri != NULL);
	{
		GFile* directory = NULL;
		GFile* _tmp0_;
		GFileEnumerator* children = NULL;
		GFile* _tmp1_;
		GFileEnumerator* _tmp2_;
		GFileInfo* file_info = NULL;
		GFile* _tmp30_;
		_tmp0_ = g_file_new_for_uri (uri);
		directory = _tmp0_;
		_tmp1_ = directory;
		_tmp2_ = g_file_enumerate_children (_tmp1_, "standard::*", G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
		children = _tmp2_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (directory);
			goto __catch0_g_error;
		}
		file_info = NULL;
		while (TRUE) {
			GFileInfo* _tmp3_ = NULL;
			GFileEnumerator* _tmp4_;
			GFileInfo* _tmp5_;
			GFileInfo* _tmp6_;
			GFileInfo* _tmp7_;
			GFileInfo* _tmp8_;
			_tmp4_ = children;
			_tmp5_ = g_file_enumerator_next_file (_tmp4_, NULL, &_inner_error0_);
			_tmp3_ = _tmp5_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (file_info);
				_g_object_unref0 (children);
				_g_object_unref0 (directory);
				goto __catch0_g_error;
			}
			_tmp6_ = _tmp3_;
			_tmp3_ = NULL;
			_g_object_unref0 (file_info);
			file_info = _tmp6_;
			_tmp7_ = file_info;
			if (!(_tmp7_ != NULL)) {
				_g_object_unref0 (_tmp3_);
				break;
			}
			_tmp8_ = file_info;
			if (g_file_info_get_file_type (_tmp8_) == G_FILE_TYPE_DIRECTORY) {
				GFile* _tmp9_;
				gchar* _tmp10_;
				gchar* _tmp11_;
				gchar* _tmp12_;
				gchar* _tmp13_;
				GFileInfo* _tmp14_;
				const gchar* _tmp15_;
				gchar* _tmp16_;
				gchar* _tmp17_;
				_tmp9_ = directory;
				_tmp10_ = g_file_get_uri (_tmp9_);
				_tmp11_ = _tmp10_;
				_tmp12_ = g_strconcat (_tmp11_, "/", NULL);
				_tmp13_ = _tmp12_;
				_tmp14_ = file_info;
				_tmp15_ = g_file_info_get_name (_tmp14_);
				_tmp16_ = g_strconcat (_tmp13_, _tmp15_, NULL);
				_tmp17_ = _tmp16_;
				play_my_music_utils_delete_uri_recursive (_tmp17_);
				_g_free0 (_tmp17_);
				_g_free0 (_tmp13_);
				_g_free0 (_tmp11_);
			} else {
				GFile* usb = NULL;
				GFile* _tmp18_;
				gchar* _tmp19_;
				gchar* _tmp20_;
				gchar* _tmp21_;
				gchar* _tmp22_;
				GFileInfo* _tmp23_;
				const gchar* _tmp24_;
				gchar* _tmp25_;
				gchar* _tmp26_;
				GFile* _tmp27_;
				GFile* _tmp28_;
				GFile* _tmp29_;
				_tmp18_ = directory;
				_tmp19_ = g_file_get_uri (_tmp18_);
				_tmp20_ = _tmp19_;
				_tmp21_ = g_strconcat (_tmp20_, "/", NULL);
				_tmp22_ = _tmp21_;
				_tmp23_ = file_info;
				_tmp24_ = g_file_info_get_name (_tmp23_);
				_tmp25_ = g_strconcat (_tmp22_, _tmp24_, NULL);
				_tmp26_ = _tmp25_;
				_tmp27_ = g_file_new_for_uri (_tmp26_);
				_tmp28_ = _tmp27_;
				_g_free0 (_tmp26_);
				_g_free0 (_tmp22_);
				_g_free0 (_tmp20_);
				usb = _tmp28_;
				_tmp29_ = usb;
				g_file_delete (_tmp29_, NULL, &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					_g_object_unref0 (usb);
					_g_object_unref0 (_tmp3_);
					_g_object_unref0 (file_info);
					_g_object_unref0 (children);
					_g_object_unref0 (directory);
					goto __catch0_g_error;
				}
				_g_object_unref0 (usb);
			}
			_g_object_unref0 (_tmp3_);
		}
		_tmp30_ = directory;
		g_file_delete (_tmp30_, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (file_info);
			_g_object_unref0 (children);
			_g_object_unref0 (directory);
			goto __catch0_g_error;
		}
		_g_object_unref0 (file_info);
		_g_object_unref0 (children);
		_g_object_unref0 (directory);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp31_;
		const gchar* _tmp32_;
		err = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp31_ = err;
		_tmp32_ = _tmp31_->message;
		g_warning ("Utils.vala:63: %s", _tmp32_);
		_g_error_free0 (err);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		g_clear_error (&_inner_error0_);
		g_assert_not_reached ();
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

gchar*
play_my_music_utils_markdown_format (const gchar* input)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* result;
	g_return_val_if_fail (input != NULL, NULL);
	_tmp0_ = string_replace (input, "&", "&amp;");
	_tmp1_ = _tmp0_;
	_tmp2_ = string_replace (_tmp1_, "<", "&#60;");
	_tmp3_ = _tmp2_;
	_tmp4_ = string_replace (_tmp3_, ">", "&#62;");
	_tmp5_ = _tmp4_;
	_g_free0 (_tmp3_);
	_g_free0 (_tmp1_);
	result = _tmp5_;
	return result;
}

void
play_my_music_utils_set_custom_css_style (GdkScreen* screen)
{
	GtkCssProvider* _tmp0_;
	GtkCssProvider* _tmp1_;
	g_return_if_fail (screen != NULL);
	_tmp0_ = granite_widgets_utils_set_theming_for_screen (screen, "\n" \
"                    .artist-title {\n" \
"                        color: #fff;\n" \
"                        text-shadow: 0px 1px 2px alpha (#000, 1);\n" \
"                    }\n" \
"                    .artist-sub-title {\n" \
"                        color: #fff;\n" \
"                        text-shadow: 0px 1px 2px alpha (#000, 1);\n" \
"                    }\n" \
"                    .playlist-tracks {\n" \
"                        background: transparent;\n" \
"                    }\n" \
"                    .mode_button_split {\n" \
"                        border-left-width: 1px;\n" \
"                    }\n" \
"                    .artist-tracks {\n" \
"                        background: rgba (245, 245, 245, 0.75);\n" \
"                    }\n" \
"                    .artist-tracks-dark {\n" \
"                        background: rgba (54, 59, 62, 0.75);\n" \
"                    }\n" \
"                    .custom_titlebar {\n" \
"                        padding-top: 0px;\n" \
"                        padding-bottom: 0px;\n" \
"                    }\n" \
"                    .track-drag-begin {\n" \
"                        border-top: 1px solid #666666;\n" \
"                    }\n" \
"                    .mobile-close-button {\n" \
"                        padding: 3px;\n" \
"                        opacity: 0.75;\n" \
"                    }\n" \
"                ", GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
	_tmp1_ = _tmp0_;
	_g_object_unref0 (_tmp1_);
}

